#include <fstream>
#include <vector>
#include <list>
#include <string>
#include <cstring>
#include <iostream>

#define MAX_NODE 1000
#define A 54059 /* a prime */
#define B 76963 /* another prime */
#define C 86969 /* yet another prime */
#define FIRSTH 37 /* also prime */


using namespace std;

unsigned int hash_str(const char* s)
{
    unsigned int h = FIRSTH;
    while (*s) {
        h = (h * A) ^ (s[0] * B);
        s++;
    }
    return h; // or return h % C;
}

int getNr(char *bufferIn, int &poz) {
    int nr = 0;
    while(bufferIn[poz] >= '0' && bufferIn[poz] <= '9') {
        nr = nr * 10 + bufferIn[poz] - '0';
        poz++;
    }
    poz++;
    return nr;
}

char *getOp(char *bufferIn, int &poz) {
    char *op;
    op = new char[100];
    while(bufferIn[poz] != ' ') {
        op[poz] = bufferIn[poz];
        poz++;
    }
    op[poz] = '\0';
    poz++;
    return op;
}

list<int> listaAd[MAX_NODE];
list<int>::iterator k, l;
int n;
char *bufferIn;

bool test(int sd, int dr);

int main() {

    ios_base::sync_with_stdio(1);
    ifstream cin("prietene.in");
    ofstream cout("prietene.out");

    int nrTeste;
    cin >> nrTeste;
    cin.get();
    for(; nrTeste > 0; nrTeste--) {
        bufferIn = new char[100];
        cin.getline(bufferIn, 100);
        int j = 0;
        n = getNr(bufferIn, j);
        //cin.get();
        int m = getNr(bufferIn, j);
        int st, dr;
        for (int i = 0; i < m; i++) {
            cin.getline(bufferIn, 100);
            //cin.get();
            j = 0;
            st = getNr(bufferIn, j);
            dr = getNr(bufferIn, j);
            listaAd[st].push_back(dr);
        }
        cin.getline(bufferIn, 100);
        //cin.get();
        j = 0;
        int q = getNr(bufferIn, j);
        for (int i = 0; i < q; i++) {
            cin.getline(bufferIn, 100);
            //cin.get();
            int j = 0;
            char *operation = getOp(bufferIn, j);
            if (operation[0] == 'q') {
                int sd = getNr(bufferIn, j), dr = getNr(bufferIn, j);
                if (test(sd, dr)) cout<<"YES\n";
                else cout<<"NO\n";
            } else if (operation[0] == 'a') {
                int sd = getNr(bufferIn, j), dr = getNr(bufferIn, j);
                listaAd[sd].push_back(dr);
                //listaAd[dr].push_back(st);
            } else if (operation[0] == 'd') {
                int sd = getNr(bufferIn, j), dr = getNr(bufferIn, j);
                for (k = listaAd[sd].begin(); k != listaAd[sd].end(); k++) {
                    if (*k == dr)
                    {
                        listaAd[sd].erase(k);
                        break;
                    }
                }
            }
        }
        for(int i = 0; i < listaAd[n].size(); i++)
            listaAd[i].clear();
    }
    return 0;
}

bool test(int sd, int dr) {
    int firstP[MAX_NODE], secondP[MAX_NODE];
    memset(firstP, 0, sizeof(firstP));
    memset(secondP, 0, sizeof(secondP));

    for(k = listaAd[sd].begin(); k != listaAd[sd].end(); k++)
    {
        firstP[*k] = 1;
        for(l = listaAd[*k].begin(); l != listaAd[*k].end(); l++)
            firstP[*l] = 1;
    }
    for(k = listaAd[dr].begin(); k != listaAd[dr].end(); k++)
    {
        secondP[*k] = 1;
        for(l = listaAd[*k].begin(); l != listaAd[*k].end(); l++)
            secondP[*l] = 1;
    }
    firstP[sd] = 0;
    firstP[dr] = 0;
    secondP[dr] = 0;
    secondP[sd] = 0;
    for(int i = 0; i <= n; i++) {
        if(firstP[i] != secondP[i]) return false;
    }
    return true;
}
